//###################################################################################
// File: tripplewrite.c
//
// Drei gleichzeitig geffnete Dateien beschreiben 
//
// !!! NICHT MIT ATMega32 versuchen !!!
//
// MAX_OPEN_FILE in dos.h muss >=3 sein !
//
//#########################################################################
// Last change: 21.02.2007
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.5
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../serial.h"
#include "../printf.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
// timeout not used !
// interrupt every 47.4ms  @ 11.0592MHz
// interrupt every 32.77ms @ 16.0000MHz
SIGNAL(SIG_OVERFLOW1)        // signal handler for timer1 overflow interrupt
//###################################################################################
{
 countclock++;
}

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 
 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

#ifdef MMC_CARD_SPI
 MMC_IO_Init();
#endif

 LCDInit();
 ser_init();

//Timer1
 TCCR1A=0; 
 TCCR1B=0x02;        //Timer1 Start Takt = F/8 => 47.4ms at 11.059MHz
 TIMSK=(1<<TOIE1);   // enable timer1 int

 sei();              //enable interrupts

 LCDCls();
 puts("FAT Tripple-Write-Test");
 LCDPos(2,1);
 puts("by Holgi");
 Delay1ms(1000);
 LCDCls();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   LCDCls();
   puts("Flash meldet sich nicht !");
   while(1);
  }
  
 RED_ON();
 GREEN_OFF();

 countclock=0;
 
 char f_id0,f_id1,f_id2;
 unsigned int i;

// Datei 0.txt, 1.txt, 2.txt schreiben
// Gre aller Dateien nachher jeweils 1376235 Bytes
 f_id0=Fopen("0.txt",F_WRITE);
 f_id1=Fopen("1.txt",F_WRITE);
 f_id2=Fopen("2.txt",F_WRITE);

 if(f_id0>=0 && f_id1>=0 && f_id2>=0)
  {
   for(i=0; i<65535; i++)
    {
     Fwrite("01234012340123401234\n",21,f_id0);
     Fwrite("56789567895678956789\n",21,f_id1);
     Fwrite("ABCDEABCDEABCDEABCDE\n",21,f_id2);
    }
    
   Fclose(f_id0);
   Fclose(f_id1);
   Fclose(f_id2);
  }

 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts

 LCDPos(2,1);
 printf("%u\n",countclock);
 
 for(;;) // loop forever
  {
  }
}

