//###################################################################################
// File: dosallocdir.c
//
// Verzeichnisse vergrern und Cluster dafr reservieren.
// Dieser Test funktioniert bei FAT12 und FAT16 nur in einem
// Unterverzeichnis !
//
//#########################################################################
// Last change: 26.09.2006
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.3
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "../dos.h"
#include "../lcd.h"
#include "../printf.h"
#include "../serial.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
// timeout not used !
// interrupt every 47.4ms  @ 11.0592MHz
// interrupt every 32.77ms @ 16.0000MHz
SIGNAL(SIG_OVERFLOW1)        // signal handler for timer1 overflow interrupt
//###################################################################################
{
 countclock++;
}

//###################################################################################
unsigned char WriteTestFile(char *name)
//###################################################################################
{
 unsigned char result;
 char f_id;

 result=F_OK;
 f_id=Fopen(name,F_WRITE);
 if(f_id>=0)
  {
   if(Fwrite("Hello World. Hello World. Hello World. Hello World.\n",52,f_id)!=52) result=F_ERROR;
   Fclose(f_id);
  }

 return result;
}

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 
 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

#ifdef MMC_CARD_SPI
 MMC_IO_Init();
#endif

 ser_init();
 LCDInit();

//Timer1
 TCCR1A=0; 
 TCCR1B=0x02;        //Timer1 Start Takt = F/8 => 47.4ms at 11.059MHz
 TIMSK=(1<<TOIE1);   // enable timer1 int

 sei();              //enable interrupts

 LCDCls();
 puts("FAT DOS-ALLOCDIR-Test");
 LCDPos(2,1);
 puts("by Holgi");
 Delay1ms(1000);
 LCDCls();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   LCDCls();
   puts("Flash meldet sich nicht !");
   while(1);
  }
  
 RED_ON();
 GREEN_OFF();

 Mkdir("test1"); //makedir test1
 Chdir("test1"); //change to dir test1

 unsigned int i;
 //Erzeuge haufenweise Dateien damit neue Cluster fr
 //das Verzeichnis reserviert werden mssen.
 for(i=0; i<1000; i++) //reicht fr Cluster mit 4 oder 8 Sektoren
  {
   unsigned int tmp;
   char filename[14];
   
   tmp=i;
   strcpy(filename,"000.txt");
   
   filename[2]=(char)(tmp%10)+'0';
   tmp=tmp/10;
   filename[1]=(char)(tmp%10)+'0';
   tmp=tmp/10;
   filename[0]=(char)(tmp%10)+'0';
   
   WriteTestFile(filename);
  }
  
 GREEN_ON();
 RED_OFF();
 puts("Ready !");
 cli(); // Disable interrupts
 
 for(;;) // loop forever
  {
  }
}

